haskore-0.2.0.3: The Haskore Computer Music System

Safe Haskell | None

Medium

# Documentation

class Construct medium where Source

Methods

prim :: a -> medium aSource

(+:+), (=:=) :: medium a -> medium a -> medium aSource

serial, parallel :: C a => [medium a] -> medium aSource

serial1, parallel1 :: [medium a] -> medium aSource

Instances

Construct T |
Construct T |
Construct (T control) |
Label label => Construct (T label control) |

class Construct medium => C medium where Source

Methods

switchBinary :: (a -> b) -> (medium a -> medium a -> b) -> (medium a -> medium a -> b) -> b -> medium a -> bSource

switchList :: (a -> b) -> ([medium a] -> b) -> ([medium a] -> b) -> medium a -> bSource

Instances

C T |
C T |

mapList :: (C b, C medium) => (a -> b) -> ([medium b] -> [medium b]) -> ([medium b] -> [medium b]) -> medium a -> medium bSource

mapListFlat :: (C b, C medium) => (a -> b) -> ([medium a] -> [medium b]) -> ([medium a] -> [medium b]) -> medium a -> medium bSource

foldList :: C medium => (a -> b) -> ([b] -> b) -> ([b] -> b) -> medium a -> bSource

foldBin :: C medium => (a -> b) -> (b -> b -> b) -> (b -> b -> b) -> b -> medium a -> bSource

listMediumFromAny :: (Construct dst, C src, C a) => src a -> dst aSource

binaryMediumFromAny :: (Construct dst, C src) => dst a -> src a -> dst aSource